/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */

/* add this header as a header of ns  */
#ifndef ns_CentralBBbase_h
#define ns_CentralBBbase_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

#include "BBbase.h"
#include <list.h>



/*****************************************************
 class name:CentralBBbaseAgent
 mission:creates a new Agent which handles requests
 	 for bandwith in the domain in which he is
	 responsible
******************************************************/
class CentralBBbaseAgent : public BBbaseAgent {
public:
	/*constructor*/
	CentralBBbaseAgent();

	/*class functions*/
	virtual int command(int argc, const char*const* argv);
        virtual void recv(Packet*, Handler*);

protected:
	int enable_fault_tolerance;/*iniatially Central Agent is not fault tolerant, */
		                           /* becomes fault tolerant only if the user */
					/*enables that characteristic*/

};

#endif // ns_CentralBBbase_h
