#include <stdio.h>

//#include <stdlib.h>

//#include <math.h>

#include "trafgen.h"


class H323_Traffic : public TrafficGenerator {

FILE *fp;
double time_old, interval_time;
int statusfile;

public:

	H323_Traffic();

	virtual double next_interval(int&);

	int on() { return on_;}

double readfiletime(FILE *fp)
{
	double time;
	if (statusfile!=0) {
		if (fscanf(fp, "%lf", &time)!=EOF){
//		printf("%lf\n", time);
		}
		else {
			time=time_old;
			statusfile=fclose(fp);
		}
	}
	else {
		time=time_old;
	}
	return (time);
}

int readfilesize(FILE *fp)
{
	int size;
	if (statusfile!=0) {
		if (fscanf(fp, "%d", &size)!=EOF){
//		printf("%d\n", size);
		}
		else {
			size=0;
		}
	}
	else {
		size=0;
	}
	return (size);
}


protected:

	void init();

	int on_;


};



H323_Traffic::H323_Traffic()

{

//	bind("rate_", &rate_);

//	bind("packet_size_", &size_);

//	bind("FRPs_", &M);

//	bind("hurst_", &H);

//	size_=s;

}


void H323_Traffic::init()
{

	statusfile=1;
	time_old=0.0;
	interval_time=0.0;
	if ((fp=fopen("/home/qos/dimitris/h323_trace.txt", "r"))==NULL)
		printf("cannot open file %s\n");

        if (agent_)
                agent_->set_pkttype(PT_H323);
}



double H323_Traffic::next_interval(int& size)

{

	double t = readfiletime(fp);
	int new_size = readfilesize(fp);
	interval_time=t-time_old;
	time_old=t;

	on_ = 1;

	size = new_size;

	return(interval_time);

}



static class H323TrafficClass : public TclClass {

	public:

	H323TrafficClass() : TclClass("Application/Traffic/H323") {}

	TclObject* create(int, const char*const*) {

		return (new H323_Traffic());
	}

} class_H323_traffic;
